unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Sockets, ExtCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    TcpClient1: TTcpClient;
    Button1: TButton;
    Edit3: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    Image1: TImage;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TcpClient1Receive(Sender: TObject; Buf: PAnsiChar;
      var DataLen: Integer);
    procedure TcpClient1Error(Sender: TObject; SocketError: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  prikaz,prikaz2:string; //odeslane,prijate prikazy
  retezec:string;        //odkladaci promenna pro nacteni nekolika pismen
  maxspeed,levels,i,pocetvytahu,floor:integer;
  a,b:integer; //takove promenne bez jmena (odkladaci)
  s,t:string;     //to same

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 a:=0;
 b:=0;
 levels:=0;
 maxspeed:=0;
 i:=0;
 floor:=0;
 pocetvytahu:=0;
 s:='';
 t:='';//zatim
 TcpClient1.RemoteHost:=Edit1.Text;
 TcpClient1.RemotePort:=Edit2.Text; //nastaveni klienta
{ prikaz2:=TcpClient1.Receiveln;
 Memo1.Text:='Prijat prikaz: '+prikaz2; //zapise do mema prijaty prikaz
 retezec:='';
 For i:=1 To 3 Do retezec:=retezec+prikaz2[i];

 if retezec='sha' then begin      //nacita pocet vytahu
  i:=8;
   while prikaz[i]<>')' do begin //nacita,do ktereho patra maji vytahy jet    VAL(prikaz[i],a,b);
    pocetvytahu:=pocetvytahu+b;
    i:=i+1;
   end;
 if retezec='lev' then begin   //jestlize jsou prvi 3 pismena "lev" (levelbutton)
  if prikaz2[6]='s' then begin //nacitani poctu poschodi
  i:=8;
  while prikaz[i]<>')' do begin
  VAL(prikaz[i],a,b);
  levels:=levels+b;
  end;
  end
  else
  i:=15;
  floor:=0;
  while prikaz[i]<>')' do begin //nacita,do ktereho patra maji vytahy jet
    VAL(prikaz[i],a,b);
    floor:=floor+b;
    i:=i+1;
   end;
   for i:=1 to pocetvytahu do begin
    Str(i,s);
    Str(floor,t);
    TcpClient1.Sendln('open '+s+' '+t);
   end;
  end
 end;}

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Label1.Caption:='Pripojuji...';
TcpClient1.Open; //pripojeni k serveru
IF TcpClient1.Connected THEN Begin
 Label1.Caption:='Pripojeno';
 TcpClient1.Sendln('lipinfo AHOJ!');
 Button1.Enabled:=False;
 Button2.Enabled:=True;
 Button3.Enabled:=True;
End
 else
 Label1.Caption:='Nepripojeno';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
TcpClient1.Close; //odpojeni klienta
Button1.Enabled:=true;
Button3.Enabled:=false;
Label1.Caption:='Odpojeno';
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
Application.Terminate;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
prikaz:=Edit3.Text;
TcpClient1.Sendln(prikaz);
Memo1.Text:='Odeslan prikaz: '+prikaz; //zapise do mema odeslany prikaz
{if prikaz='DESTRUCTION'then begin
 for i:=1 to pocetvytahu do begin
  Str(i,s);
  TcpClient1.Sendln('speed '+s+'10000);
  TcpClient1.Sendln('floor '+s+'0);
 end;
end;}

end;


procedure TForm1.TcpClient1Receive(Sender: TObject; Buf: PAnsiChar;
  var DataLen: Integer);   //toto by melo zajistit zajisteni a potvrzeni
                           //obdrzeni prikazu od serveru
begin
 prikaz2:=TcpClient1.Receiveln;
 Memo1.Text:='Prijat prikaz: '+prikaz2; //zapise do Mema prijaty prikaz
 retezec:='';
 For i:=1 To 3 Do retezec:=retezec+prikaz2[i];

 if retezec='sha' then begin      //nacita pocet vytahu
  i:=8;
   while prikaz[i]<>')' do begin //nacita,do ktereho patra maji vytahy jet    VAL(prikaz[i],a,b);
    pocetvytahu:=pocetvytahu+b;
    i:=i+1;
   end;
 if retezec='lev' then begin   //jestlize jsou prvi 3 pismena "lev" (levelbutton)
  if prikaz2[6]='s' then begin //nacitani poctu poschodi
  i:=8;
  while prikaz[i]<>')' do begin
  VAL(prikaz[i],a,b);
  levels:=levels+b;
  end;
  end
  else
  i:=15;
  floor:=0;
  while prikaz[i]<>')' do begin //nacita,do ktereho patra maji vytahy jet
    VAL(prikaz[i],a,b);
    floor:=floor+b;
    i:=i+1;
   end;
   for i:=1 to pocetvytahu do begin
    Str(i,s);
    Str(floor,t);
    TcpClient1.Sendln('lipinfo '+t);
    TcpClient1.Sendln('floor '+s+' '+t);
   end;
  end
 end;
end;

procedure TForm1.TcpClient1Error(Sender: TObject; SocketError: Integer);
begin
 Label1.Caption:='Chyba v pripojeni';
end;

end.

{POZNAMKA: Nekdy je pri kompilaci treba kompilovat dvakrat-vyskakuji tam nejake
           divne chyby.Ale protoze jim nerozumim,nemohu je odstranit.}
